import java.awt.*;

public class InfoCanvas extends Canvas {
 
 private int num;
 private FontMetrics fm;
 
 public InfoCanvas() {
  setBackground(Color.white);
  Font f=new Font("SansSerif",Font.BOLD,14);
  setFont(f);
  fm=getFontMetrics(f);
  num=0;
 }
 
 public void paint(Graphics g) {
  int largeur=fm.stringWidth(""+num);
  int hauteur=fm.getHeight();
  int x=(getSize().width-largeur)/2;
  int y=(getSize().height-hauteur)/2+hauteur;
  g.drawString(""+num,x,y);
 }
 
 public void setNum(int n) {
  num=n;
  repaint();
 }
 
}

