import java.applet.*;
import java.awt.*;
import java.awt.event.*;

public class des extends Applet 
 implements ActionListener, Runnable {

 Histo1D hd;
 HistoGra hist;
 Button autoButton;
 InfoCanvas infoTirages;
 Thread auto;
 
 public void init() {
  setLayout(new BorderLayout(4,4));
  String S=getParameter("mode");
  if (S==null) hd=new Histo1D();
  else if (S.equals("1D")) hd=new Histo1D();
  else if (S.equals("somme2D")) hd=new Somme2D();
  else if (S.equals("max2D")) hd=new Max2D();
  else if (S.equals("diff2D")) hd=new Diff2D();
  else if (S.equals("Depipe")) hd=new Depipe();
  else if (S.equals("Total12")) hd=new Total12();
  hist=new HistoGra(hd);
  hist.setMaxi(55);
  add(BorderLayout.CENTER,hist);
  add(BorderLayout.WEST,panelCom());
 }

 Panel panelCom() {
  Panel p=new Panel();
  p.setLayout(new BorderLayout());
  Panel ps=new Panel();
  p.add(BorderLayout.NORTH,ps);
  ps.setLayout(new GridLayout(5,1,4,4));
  Button b=new Button("Tirage");
  b.addActionListener(this);
  ps.add(b);
  b=new Button("100 fois");
  b.addActionListener(this);
  ps.add(b);
  autoButton=new Button("Auto");
  autoButton.addActionListener(this);
  autoButton.setActionCommand("Auto");
  ps.add(autoButton);
  b=new Button("R.A.Z");
  b.addActionListener(this);
  ps.add(b);
  infoTirages=new InfoCanvas();
  ps.add(infoTirages);
  return p;
 }
 
 void updateStatut() {
  hist.repaint();
  infoTirages.setNum(hd.getNbTirages());
 }
 
 public void actionPerformed(ActionEvent e) {
  if ("Tirage".equals(e.getActionCommand())) {
   hd.tirage();
   updateStatut();
  }
  else if ("100 fois".equals(e.getActionCommand())) {
   for (int i=0; i<100; i++) hd.tirage();
   updateStatut();
  } 
  else if ("R.A.Z".equals(e.getActionCommand())) {
   hd.raz();
   updateStatut();
  }
  else if ("Auto".equals(e.getActionCommand())) {
   autoButton.setLabel("Stop");
   autoButton.setActionCommand("Stop");
   autoDepart();
  } 
  else if ("Stop".equals(e.getActionCommand())) {
   autoButton.setLabel("Auto");
   autoButton.setActionCommand("Auto");
   stop();
  }
 }
 
 void autoDepart() {
  if (auto==null) {
   auto=new Thread(this);
   auto.start();
  }
 }
 
 public Insets getInsets() {
  return new Insets(4,4,4,4);
 }
 
 public void run() {
  while (auto!=null) {
   hd.tirage();
   updateStatut();
   try {
    Thread.sleep(200);
   } catch (InterruptedException e){}
  }
  auto=null;
 }
 
 public void stop() {
  auto=null;
 }

}

