import java.awt.*;
import java.awt.event.*;
import java.applet.*;

public class Urne extends Applet implements ActionListener {

 UrneArbre arbre=new UrneArbre();
 Button tirage=new Button("Tirage");
 Button tir100=new Button("100 fois");
 //Button probas=new Button("Probas");
 
 public void init() {
  setBackground(Color.lightGray);
  parametrise();
  setLayout(new BorderLayout(4,4));
  add(BorderLayout.CENTER,arbre);
  Panel p=new Panel();
  add(BorderLayout.WEST,p);
  p.setBackground(Color.lightGray);
  p.setLayout(new BorderLayout());
  Panel p1=new Panel();
  p.add(BorderLayout.NORTH,p1);
  p1.setLayout(new GridLayout(3,1,4,4));
  p1.add(tirage);
  tirage.addActionListener(this);
  p1.add(tir100);
  tir100.addActionListener(this);
  //p1.add(probas);
  //probas.addActionListener(this);
 }
 
 void parametrise() {
  //lecture des paramtres
  String S;
  S=getParameter("remise");
  if (S!=null && S.equals("oui")) arbre.urne.remise=true;
  S=getParameter("tirage");
  if (S!=null) 
   try {
    arbre.urne.nbTirage=Integer.parseInt(S);
   } catch (Exception e) {
    arbre.urne.nbTirage=3;
   }
  defUrne(getParameter("bleu"),getParameter("rouge"),getParameter("vert"));
 }

 public int convertir(String nStr, int valDef) {
  int n=valDef;
  if (nStr!=null) 
   try {
    n=Integer.parseInt(nStr);
   } catch (Exception e) {
    n=valDef;
   }
  return n;
 }
 
 public void defUrne(String bstr, String rstr, String vstr) {
  int b=convertir(bstr,arbre.urne.nbBleu);
  int r=convertir(rstr,arbre.urne.nbRouge);
  int v=convertir(vstr,arbre.urne.nbVert);
  arbre.urne.defUrne(b,r,v);
 }

 public void defMode(int n) {
  arbre.urne.nbTirage=n;
  arbre.urne.resetChoix();
 }

 public void defRemise(boolean b) {
  arbre.urne.remise=b;
 }

 public void montreProba(boolean b) {
  arbre.montreProba=b;
 }
 
 public void dessiner() {
  arbre.repaint();
 }

 public void tirages(int n) {
  arbre.urne.faireTirage(n);
  arbre.repaint();
 }
 
 public void actionPerformed(ActionEvent e) {
  if (e.getSource()==tirage) {
   arbre.urne.faireTirage();
   arbre.repaint();
  }
  else if (e.getSource()==tir100) {
   arbre.urne.faireTirage(100);
   arbre.repaint();
  }
  //else if (e.getSource()==probas) {
  // arbre.montreProba=!arbre.montreProba;
  // arbre.repaint();
  //} 
 }
 
 public Insets getInsets() {
  return new Insets(4,4,4,4);
 }
 
}
