/*
 * Copyright (c) 1999-2000 Kostrzewa Bruno
 *
 * Permission to use, copy, hack, and distribute this software and its
 * documentation for NON-COMMERCIAL purposes and without fee is hereby
 * granted provided that this copyright notice appears in all copies.
 * 
 * Trace.java
 * JDK 1.1  
 * Version 1.2 Rvision 01/08/2000
 * Partie du package imageo reprsentant la trace laisse par
 * des points imageo.
 *
 */

package jkb.imageo;

import java.util.Vector;

public class Trace extends Vector {

 public Trace() {
  super(1000);
 }
 
 public void ajoute(double x, double y) {
  boolean ok=true;
  double m[];
  int i=0;
  if (size()<1000) {
   while (ok && i<size()) {
    m=coord(i);
    if (m[0]==x && m[1]==y) ok=false;
    else i++;
   } 
   if (ok) {
    m=new double[2];
    m[0]=x; m[1]=y;
    addElement(m);
   } 
  } 
 }

 public double[] coord(int n) {
  return (double[])elementAt(n);
 }
 
}

