// position tortue
var xt=0;
var yt=0;
var zt=0;
// matrice direction tortue
var c11=0;
var c12=1;
var c13=0;
var c21=-1;
var c22=0;
var c23=0;
var c31=0;
var c32=0;
var c33=1;
// points et faces
var points=new Array();
var faces=new Array();

function initialise() {
  xt=0.0; yt=0.0; zt=0.0;
  c11=0; c12=1; c13=0; 
  c21=-1; c22=0; c23=0; 
  c31=0; c32=0; c33=1;
  points.length=0;
  faces.length=0;
}

function egalZero(d) {
  return (Math.abs(d)<0.0000000001);
}

function numPoint(x,y,z) {
  var rep=-1;
  var i=0;
  var p;
  while (rep==-1 && i<points.length) {
   p=points[i];
   if (egalZero(p[0]-x) && egalZero(p[1]-y) && egalZero(p[2]-z)) rep=i;
   else i++;
  }
  return rep;
}

function ajoutePoint(x,y,z) {
  var p=new Array();
  p[0]=x; p[1]=y; p[2]=z;
  points[points.length]=p;
}

function av(d) {
  xt=xt+d*c11;
  yt=yt+d*c12;
  zt=zt+d*c13;
}
	
function re(d) {
  av(-d);
}
	
function td(a) {
  var cs = Math.cos(a*Math.PI/180);
  var sn = Math.sin(a*Math.PI/180);
  var b11=((c11*cs)-(c21*sn));
  var b12=((c12*cs)-(c22*sn));
  var b13=((c13*cs)-(c23*sn));
  c21=((c21*cs)+(c11*sn));
  c22=((c22*cs)+(c12*sn));
  c23=((c23*cs)+(c13*sn));
  c11=b11;
  c12=b12;
  c13=b13;
}
	
function tg(a) {
  td(-a);
}
	
function ig(a) {
  var cs = Math.cos(a*Math.PI/180);
  var sn = Math.sin(a*Math.PI/180);
  var b21=((c21*cs)-(c31*sn));
  var b22=((c22*cs)-(c32*sn));
  var b23=((c23*cs)-(c33*sn));
  c31=((c31*cs)+(c21*sn));
  c32=((c32*cs)+(c22*sn));
  c33=((c33*cs)+(c23*sn));
  c21=b21;
  c22=b22;
  c23=b23;
}

function id(a) {
  ig(-a);
}

function pq(a) {
  var cs = Math.cos(a*Math.PI/180);
  var sn = Math.sin(a*Math.PI/180);
  var b11=((c11*cs)-(c31*sn));
  var b12=((c12*cs)-(c32*sn));
  var b13=((c13*cs)-(c33*sn));
  c31=((c31*cs)+(c11*sn));
  c32=((c32*cs)+(c12*sn));
  c33=((c33*cs)+(c13*sn));
  c11=b11;
  c12=b12;
  c13=b13;
}

function ca(a) {
  pq(-a);
}

function face(c,n) {
// polygone rgulier  n cts de longueur c
  var tmp=new Array(n);
  var num=-1;
  for (var i=0; i<n; i++) {
    av(c); 
    num=numPoint(xt,yt,zt);
    if (num==-1) {
      ajoutePoint(xt,yt,zt);
      num=points.length-1;
    }
    tmp[i]=num;
    tg(360/n);
  }
  faces[faces.length]=tmp;
}

function faireFigure() {
  var S="";
  var p;
  document.imageo.raz();
  for (var i=0; i<points.length; i++) {
   p=points[i];
   S=p.join(" ");
   document.imageo.ajoutePoint(S);
  }
  for (var i=0; i<faces.length; i++) {
   p=faces[i];
   S=p.join(" ");
   document.imageo.ajouteFace(S);
  }
  document.imageo.affiche();
}

function donneScript() {
  var S="";
  var p;
  for (var i=0; i<points.length; i++) {
   p=points[i];
   S=S+"P"+i+"=point("+p[0]+","+p[1]+","+p[2]+") \n";
  }
  for (var i=0; i<faces.length; i++) {
   p=faces[i];
   S=S+"face(P"+p[0]+",P"+p[1]+",P"+p[2]+",P"+p[3]+") \n";
  }
  return S;
}

