//utilisation de l'applet ImageoFig pour des constructions
// la rgle et au compas
var initSrc="couleurfond=vert";
var postSrc="";
var nPoints=0;
var tPointLibre=0;
var tPoint=1;
var tDroite=2;
var tCercle=3;
var fig=new Array();
 
function GeoObj(t,n,i,c) {
 this.type=t;
 this.nom=n;
 this.instr=i;
 this.points=c;
}

function ajoute(o) {
 fig[fig.length]=o;
}

function ajouteListesPoints(nom) {
 document.formu.listepoints1.options[document.formu.listepoints1.options.length]=
new Option(nom,nom,false,false);
 document.formu.listepoints2.options[document.formu.listepoints2.options.length]=
new Option(nom,nom,false,false);
 document.formu.listepoints3.options[document.formu.listepoints3.options.length]=
new Option(nom,nom,false,false);
 document.formu.listepoints4.options[document.formu.listepoints4.options.length]=
new Option(nom,nom,false,false);
}

function ajouteListesDroites(n1,n2) {
 document.formu.listedroites1.options[document.formu.listedroites1.options.length]=
new Option("("+n1+","+n2+")","D"+n1+n2,false,false);
 document.formu.listedroites2.options[document.formu.listedroites2.options.length]=
new Option("("+n1+","+n2+")","D"+n1+n2,false,false);
 document.formu.listedroites3.options[document.formu.listedroites3.options.length]=
new Option("("+n1+","+n2+")","D"+n1+n2,false,false);
}

function ajouteListesCercles(n1,n2) {
 document.formu.listecercles1.options[document.formu.listecercles1.options.length]=
new Option("C("+n1+","+n2+")","C"+n1+n2,false,false);
 document.formu.listecercles2.options[document.formu.listecercles2.options.length]=
new Option("C("+n1+","+n2+")","C"+n1+n2,false,false);
 document.formu.listecercles3.options[document.formu.listecercles3.options.length]=
new Option("C("+n1+","+n2+")","C"+n1+n2,false,false);
}

function ajoutePoint() {
 updateFig();
 ajoute(new GeoObj(tPointLibre,"P"+nPoints,"=point",""));
 ajouteListesPoints("P"+nPoints);
 nPoints++;
 dessineFig();
}

function ajoutePointE(nom,def) {
 ajoute(new GeoObj(tPoint,nom,"="+def,""));
 ajouteListesPoints(nom);
}

function ajouteDroiteE(n1,n2) {
 ajoute(new GeoObj(tDroite,"D"+n1+n2,"=droite("+n1+","+n2+")",n1+n2));
 ajouteListesDroites(n1,n2);
}

function ajouteDroite(n1,n2) {
 if (n1==n2) {
  alert("Il faut deux points distincts pour faire une droite !");
  return;
 }
 updateFig();
 ajoute(new GeoObj(tDroite,"D"+n1+n2,"=droite("+n1+","+n2+")",n1+" "+n2));
 ajouteListesDroites(n1,n2);
 dessineFig();
}

function ajouteCercleE(n1,n2) {
 ajoute(new GeoObj(tCercle,"C"+n1+""+n2,"=cercle("+n1+","+n2+")",n2));
 ajouteListesCercles(n1,n2);
}

function ajouteCercle(n1,n2) {
 updateFig();
 ajoute(new GeoObj(tCercle,"C"+n1+""+n2,"=cercle("+n1+","+n2+")",n2));
 ajouteListesCercles(n1,n2);
 dessineFig();
}

function donneObj(n) {
 var rep=null;
 var i=0;
 while (rep==null && i<fig.length) {
  if (fig[i].nom==n) rep=fig[i];
  else i++;
 }
 return rep;
}

function pointCommun(n1,n2) {
 var rep="";
 var o1=donneObj(n1);
 var o2=donneObj(n2);
 if (o1!=null && o2!=null) {
  var tab=o1.points.split(" ");
  var i=0;
  while (rep=="" && i<tab.length) {
   if (o2.points.indexOf(tab[i])>=0) rep=tab[i];
   else i++;
  }
 }
 return rep;
}

function signalePoint(n1,n2) {
 var o=donneObj(n2);
 if (o!=null) o.points=o.points+" "+n1;
}

function ajouteIntersectionDD(n1,n2) {
 if (n1==n2) {
  alert("Il faut deux droites distinctes !");
  return;
 }
 updateFig();
 ajoute(new GeoObj(tPoint,"P"+nPoints,"=intersection("+n1+","+n2+")"),"");
 signalePoint("P"+nPoints,n1);
 signalePoint("P"+nPoints,n2);
 ajouteListesPoints("P"+nPoints);
 nPoints++;
 dessineFig();
}

function ajouteIntersectionDC(n1,n2) {
 updateFig();
 var commun=pointCommun(n1,n2);
 if (commun=="") {
 ajoute(new GeoObj(tPoint,"P"+nPoints,"=intersection("+n1+","+n2+",1)"),"");
 signalePoint("P"+nPoints,n1);
 signalePoint("P"+nPoints,n2);
 ajouteListesPoints("P"+nPoints);
 nPoints++;
 ajoute(new GeoObj(tPoint,"P"+nPoints,"=intersection("+n1+","+n2+",2)"),"");
 signalePoint("P"+nPoints,n1);
 signalePoint("P"+nPoints,n2);
 ajouteListesPoints("P"+nPoints);
 nPoints++;
 }
 else {
 ajoute(new GeoObj(tPoint,"P"+nPoints,"=intersection("+n1+","+n2+","+commun+")"),"");
 signalePoint("P"+nPoints,n1);
 signalePoint("P"+nPoints,n2);
 ajouteListesPoints("P"+nPoints);
 nPoints++;
 }
 dessineFig();
}

function updateFig() {
 for (var i=0; i<fig.length; i++) {
  if (fig[i].type==tPointLibre) { 
   var x=document.imageoview.valeur(fig[i].nom,1);
   var y=document.imageoview.valeur(fig[i].nom,2);
   fig[i].instr="=point("+x+","+y+")";
  }
 }
}

function dessineFig() {
 var s=initSrc;
 for (var i=0; i<fig.length; i++) s=s+"\n"+fig[i].nom+fig[i].instr;
 document.imageoview.execScript(s+"\n"+postSrc);
}

