import java.applet.*;
import java.awt.*;
import jkb.geo3d.*;

// Applet zfxy Version 0.0
// tracer la surface d'quation z=f(x,y)

public class zfxy extends Applet {
    Surface fig;

    public void init() {
	fig=new Surface();
 	setLayout(new BorderLayout());		
	add("Center", fig);
    }

    public void start() {
	String comstr;
	Double d;
	Integer n;
	d=null;
	comstr=getParameter("echelle");
	if (comstr!=null && comstr.length()>0) {
	    d=new Double(comstr);
	    if (d!=null) fig.R.fixeEchelle(d.doubleValue());
	}
	comstr=getParameter("equation");
	if (comstr!=null && comstr.length()>0) fig.definirSurface(comstr);
	comstr=getParameter("mailles");
	if (comstr!=null && comstr.length()>0) {
	    n=new Integer(comstr);
	    if (n!=null) fig.nombreLignes(n.intValue());
	}
	comstr=getParameter("cube");
	if (comstr!=null && comstr.length()>0) fig.definirCube(comstr);
	comstr=getParameter("plan");
	if (comstr!=null && comstr.length()>0) fig.definirPlan(comstr);
    }

    public void trace(String S) {
	fig.definirSurface(S);
	fig.repaint();
    }

    public void defNombreLignes(int n) {
	fig.nombreLignes(n);
    }

    public void defDimensions(String S) {
	fig.definirCube(S);
    }

    public int statut() {
	return fig.statut;
    }

    public void defPlan(String S) {
	fig.definirPlan(S);
    }
}
