/*
 * Copyright (c) 1999-2000 Kostrzewa Bruno
 *
 * Permission to use, copy, hack, and distribute this software and its
 * documentation for NON-COMMERCIAL purposes and without fee is hereby
 * granted provided that this copyright notice appears in all copies.
 * 
 * minilogo.java
 * JDK 1.1 
 * Version 1.1 Rvision 30/12/1999
 * Applet permettant d'excuter un programme minilogo. 
 * Version 1.1a Rvision 30/06/2006
 *
 */

import java.util.*;
import java.applet.*;
import java.awt.*;
import jkb.calkul.*;
import jkb.mlogo.*;

public class ConsLogo extends Applet {
 TextArea zoneTexte;
 LogoExe logo;
 Vector prog;
 
 public void init() {
  zoneTexte=new TextArea();
  zoneTexte.setEditable(false);
  setLayout(new BorderLayout());
  add("Center",zoneTexte);
  logo=new LogoExe();
  logo.defZoneTexte(zoneTexte);
 }
 
 public void exec(String progStr) {
  if (progStr!=null && progStr.length()>0) {
   //zoneTexte.append("Compilation en cours..."+'\n');
   zoneTexte.setText("");
   LogoStr LS=new LogoStr(progStr);
   Vector prog=LS.compile(logo.dico);
   //zoneTexte.append("Compilation termine..."+'\n');
   if (prog==null) {
    zoneTexte.setText(LS.messageErreur()+"("+LS.numLigne+","+LS.numColonne+")");
   }
   else {
    //zoneTexte.append("Excution en cours..."+'\n');
    logo.execProg(prog,true);
    //zoneTexte.append("Excution termine."+'\n'+'\n');
    zoneTexte.append("\nOK.");
   } 
  }
  else zoneTexte.setText("Pas de programme  excuter."+'\n');  
 } 
 
}

