/**
 * Frquence de tirage d'un d
 */
 
public class Histo1D extends HistoData {

 int nbTirages;
 
 public Histo1D() {
  super();
  nbTirages=0;
  initVals();
 }

 public void initVals() {
  for (int i=1; i<7; i++) addData(""+i,0.0);
 }
 
 public int valeurTirage() {
  return (int)Math.ceil(Math.random()*6);
 }
 
 public void tirage() {
  double f;
  int n=valeurTirage();
  int nb=nbVals();
  int test;
  for (int i=0; i<nb; i++) {
   test=Integer.parseInt(getDataNom(i));
   if (test==n) f=(getDataVal(i)*0.01*nbTirages+1)/(nbTirages+1);
   else f=(getDataVal(i)*0.01*nbTirages)/(nbTirages+1);
   setDataVal(i,f*100);
  }
  nbTirages++;
 }

 public int getNbTirages() {
  return nbTirages;
 }
 
 public void raz() {
  for (int i=0; i<nbVals(); i++) setDataVal(i,0);
  nbTirages=0;  
 }
 
}

