/**
 * Donnes  reprsenter par un tableau ou un histogramme
 */

import java.util.Vector;

public class HistoData {
 
 private Vector dat;
 
 public HistoData() {
  dat=new Vector();
 }

 public HistoData(int n) {
  dat=new Vector(n);
 }

 public void addData(String S, double val) {
  dat.addElement(new HistoVal(S,val));
 }
 
 public void setDataVal(int n, double val) {
  HistoVal v=getData(n);
  v.setVal(val);
 }

 public void setDataNom(int n, String S) {
  HistoVal v=getData(n);
  v.setNom(S);
 }
 
 public HistoVal getData(int n) {
  return (HistoVal)dat.elementAt(n);
 }
 
 public double getDataVal(int n) {
  HistoVal v=getData(n);
  return v.getVal();
 }

 public String getDataNom(int n) {
  HistoVal v=getData(n);
  return v.getNom();
 }

 public int nbVals() {
  return dat.size();
 }
 
 public double valMaxi() {
  double d=getDataVal(0);
  for (int i=1; i<dat.size(); i++) 
   if (getDataVal(i)>d) d=getDataVal(i);
  return d; 
 }
 
 public double valMini() {
  double d=getDataVal(0);
  for (int i=1; i<dat.size(); i++) 
   if (getDataVal(i)<d) d=getDataVal(i);
  return d; 
 }
 
 public void vider() {
  dat.removeAllElements();
 }

}
 
class HistoVal {
 String nom;
 double val;
 
 HistoVal(String nom, double val) {
  this.nom=nom;
  this.val=val;
 }

 double getVal() {
  return val;
 }
 
 void setVal(double v) {
  val=v;
 }
 
 String getNom() {
  return nom;
 }
 
 void setNom(String S) {
  nom=S;
 }
 
}

 
