import java.applet.*;
import java.awt.*;
import java.awt.event.*;

public class quatred extends Applet 
 implements ActionListener, Runnable {

 Histo1D[] hd;
 HistoGra[] hist;
 Button autoButton;
 InfoCanvas infoTirages;
 Thread auto;
 int num_pipe;
 int repos;
 
 public void init() {
  repos=250;       
  setLayout(new BorderLayout(4,4));
  Panel p=new Panel();
  p.setLayout(new GridLayout(2,2,4,4));
  hd=new Histo1D[4];
  hist=new HistoGra[4];
  num_pipe=(int)Math.floor(Math.random()*4);
  for (int i=0; i<4; i++) {
   if (i!=num_pipe) hd[i]=new Histo1D();
   else hd[i]=new Depipe();
   hist[i]=new HistoGra(hd[i]);
   hist[i].setMaxi(55);
   p.add(hist[i]);
  }
  add(BorderLayout.CENTER,p);
  add(BorderLayout.WEST,panelCom());
 }

 Panel panelCom() {
  Panel p=new Panel();
  p.setLayout(new BorderLayout());
  Panel ps=new Panel();
  p.add(BorderLayout.NORTH,ps);
  ps.setLayout(new GridLayout(5,1,4,4));
  Button b=new Button("Tirage");
  b.addActionListener(this);
  ps.add(b);
  b=new Button("100 fois");
  b.addActionListener(this);
  ps.add(b);
  autoButton=new Button("Auto");
  autoButton.addActionListener(this);
  autoButton.setActionCommand("Auto");
  ps.add(autoButton);
  b=new Button("R.A.Z");
  b.addActionListener(this);
  ps.add(b);
  infoTirages=new InfoCanvas();
  ps.add(infoTirages);
  return p;
 }
 
 void updateStatut() {
  for (int i=0; i<4; i++) hist[i].repaint();
  infoTirages.setNum(hd[0].getNbTirages());
 }
 
 public void actionPerformed(ActionEvent e) {
  if ("Tirage".equals(e.getActionCommand())) {
   for (int i=0; i<4; i++) hd[i].tirage();
   updateStatut();
  }
  else if ("100 fois".equals(e.getActionCommand())) {
   for (int k=0; k<100; k++) 
    for (int i=0; i<4; i++) hd[i].tirage();
   updateStatut();
  } 
  else if ("R.A.Z".equals(e.getActionCommand())) {
   for (int i=0; i<4; i++) hd[i].raz();
   updateStatut();
  }
  else if ("Auto".equals(e.getActionCommand())) {
   autoButton.setLabel("Stop");
   autoButton.setActionCommand("Stop");
   autoDepart();
  } 
  else if ("Stop".equals(e.getActionCommand())) {
   autoButton.setLabel("Auto");
   autoButton.setActionCommand("Auto");
   stop();
  }
 }
 
 void autoDepart() {
  if (auto==null) {
   auto=new Thread(this);
   auto.start();
  }
 }
 
 public Insets getInsets() {
  return new Insets(4,4,4,4);
 }
 
 public void run() {
  while (auto!=null) {
   for (int i=0; i<4; i++) hd[i].tirage();
   updateStatut();
   try {
    Thread.sleep(repos);
   } catch (InterruptedException e){}
  }
  auto=null;
 }
 
 public void stop() {
  auto=null;
 }

}

