import java.util.*;
import java.applet.*;
import java.awt.*;

//zone de jeu du morpion

class MorpionView extends Canvas {

 public static int LCase = 20;
// public static int LargJ = 11*LCase;
// public static int HautJ = 11*LCase;
// public static int HautL = 20;
 double Valeur[]=
    {0.01,       //0 soit pas de case occupe
     0.03,       //1 soit 1 case occupe par le joueur
     0.5,        //2 soit 2 cases occupes par le joueur
     100,        //3 soit 3 cases occupes par le joueur
     10000,      //4 soit 4 cases occupes par le joueur
     0.1,        //5 soit 1 case occupe par ordi
     0,          //6 soit 1 case joueur et 1 case ordi
     0,0,0,      //7,8,9
     2,          //10 soit 2 cases occupes par ordi
     0,0,0,0,    //11,12,13,14
     150,        //15 soit 3 cases occupes par ordi
     0,0,0,0,    //16,17,18,19
     1000000,    //20 soit 4 cases occupes par ordi
     1000000};   //21 soit 4 ordi et 1 joueur

 Color CouleurFond;
 Color CouleurAxes;
 Color CouleurJoueur;
 Color CouleurOrdi;
 Color CouleurSol;
 int MargeX = 2;
 int MargeY = 2;
 int A[] = new int[100];
 //contenu de la grille: 0=rien; 1=joueur; 5=ordi
 double B[] = new double[100];
 //note attribue  la case
 int Clef[] = new int[5]; 
 //srie des 5 cases gagnantes
 int NombreCoups=0;
 int Fini=0;
 boolean FinSol=false;
 int RedrawFlag=0;
 Label MsgLabel;
 
 MorpionView(Label lab) {
  CouleurFond = Color.white;
  CouleurAxes = Color.black;
  CouleurJoueur = Color.blue;
  CouleurOrdi = Color.red;
  CouleurSol = Color.green;
  MsgLabel=lab;
  setSize(2*MargeX+11*LCase, 2*MargeY+11*LCase);
  Initialise();
 }

 public void Initialise() {
 int i;
 for (i=0; i<100; i++) {
  A[i]=0; B[i]=0.0; //tableau vide
  }
 NombreCoups=0;
 Fini=0;
 FinSol=false;
 RedrawFlag=0;
 MsgLabel.setText("A vous de jouer...");
 FinSol=false;
 }
 
 
 public void update(Graphics g) {
  paint(g);
 }

 public void paint(Graphics g) {
  if (RedrawFlag==0) DessineFond(g);
  DessineCroix(g);
  RedrawFlag=0;
 }
 
 public void DessineFond(Graphics g) {
  int i,l,h;
  FontMetrics fm;
  g.setColor(CouleurFond);
  g.fillRect(0,0,size().width,size().height);
  g.setColor(CouleurAxes);
  MargeX=(size().width-11*LCase)/2;
  MargeY=(size().height-11*LCase)/2;
  fm=g.getFontMetrics();
  h=fm.getAscent() + fm.getDescent(); 
  l=fm.charWidth('9');
  for (i=0; i<10; i++) {
   g.drawString(Integer.toString(i), MargeX+(i+1)*LCase+(LCase-l) / 2,
                MargeY+LCase-h/2);
  }          
  for (i=0; i<12; i++) {
   g.drawLine(MargeX, MargeY+i*LCase, MargeX+11*LCase, MargeY+i*LCase);
  }
  for (i=0; i<10; i++) {
   g.drawString(Integer.toString(i), MargeX+(LCase-l) / 2, 
               MargeY+(i+1)*LCase+LCase-h/2);
  }
  for (i=0; i<12; i++) {
   g.drawLine(MargeX+i*LCase, MargeY, MargeX+i*LCase, MargeY+11*LCase);
  }  
 }
 
 void DessineCroix(Graphics g) {
  int i,j,l,h;
  int k=0;
  String c=" ";
  FontMetrics fm;
  fm=g.getFontMetrics();
  h=fm.getAscent() + fm.getDescent(); 
  l=fm.charWidth('X');
  for (i=0; i<10; i++) {
   for (j=0; j<10; j++) {
    k=10*j+i;
    if (A[k]==5) {
     c="O";
     g.setColor(CouleurOrdi);
    } 
    else if (A[k]==1) {
     c="X";
     g.setColor(CouleurJoueur);
    } 
    else c=" ";
    if (A[k]!=0)
     g.drawString(c, MargeX+(i+1)*LCase+(LCase-l) / 2,
                MargeY+(j+1)*LCase+LCase-h/2);
   }             
  }
  if (FinSol) AffSol(g);
 }

 void AffSol(Graphics g) {
  int i,j,l,h,n;
  int k=0;
  String c=" ";
  FontMetrics fm;
  fm=g.getFontMetrics();
  h=fm.getAscent() + fm.getDescent(); 
  l=fm.charWidth('X');
  for (n=0; n<5; n++) {
   k=Clef[n];
   if (A[k]==5) {
    c="O";
    g.setColor(CouleurSol);
   } 
   else if (A[k]==1) {
    c="X";
    g.setColor(CouleurSol);
   } 
   else c=" ";
   j=k/10;
   i=k-10*j;
   if (A[k]!=0)
     g.drawString(c, MargeX+(i+1)*LCase+(LCase-l) / 2,
                MargeY+(j+1)*LCase+LCase-h/2);
  }
 }
 
 void Affiche(int mode) {
  RedrawFlag=mode;
  repaint();
  //RedrawFlag=0;
 }
 
 void Solve(int Gagnant) {
  int i,j,k;
  int Sol;
  int TestNum=0;
  boolean fin;
  fin=false;
  Sol=5*Gagnant;
  //balayage par srie verticale
  for (i=0; i<=9; i++) {
   for (j=0; j<=5; j++) {
    if (!fin) {
     TestNum=0;
     for (k=0; k<=4; k++) {
      Clef[k]=10*i+j+k;
      if (A[Clef[k]]==Gagnant) TestNum=TestNum+A[Clef[k]];
     }
    } 
    if (TestNum==Sol) fin=true;
   }
  } 
  for (i=0; i<=9; i++) {
   for (j=0; j<=5; j++) {
    if (!fin) {
     TestNum=0;
     for (k=0; k<=4; k++) {
      Clef[k]=i+10*j+10*k;
      if (A[Clef[k]]==Gagnant) TestNum=TestNum+A[Clef[k]];
     }
    } 
    if (TestNum==Sol) fin=true;
   }
  }
  for (i=0; i<=5; i++) {
   for (j=0; j<=5; j++) {
    if (!fin) {
     TestNum=0;
     for (k=0; k<=4; k++) {
      Clef[k]=10*i+j+11*k;
      if (A[Clef[k]]==Gagnant) TestNum=TestNum+A[Clef[k]];
     }
    } 
    if (TestNum==Sol) fin=true;
   }
  } 
  for (i=4; i<=9; i++) {
   for (j=0; j<=5; j++) {
    if (!fin) {
     TestNum=0;
     for (k=0; k<=4; k++) {
      Clef[k]=i+10*j+9*k;
      if (A[Clef[k]]==Gagnant) TestNum=TestNum+A[Clef[k]];
     }
    } 
    if (TestNum==Sol) fin=true;
   }
  } 
  FinSol=fin;
 }
 
 public void CalcNote(int C, int J1, int J2, int K1, int K2) {
  // traitement ordinateur; mise  jour des notes dans B(i) 
  // C=passage d'une case  l'autre soit 1,9,10 ou 11
  // J1 et J2=limites horizontales 
  // K1 et K2=limites verticales 
  int i;
  int j;          //compteur en ligne
  int k;          //compteur en colonne de 10 en 10
  int P;          //compteur
  int Z;          //contenu d'un groupe de 5 cases
  double Note;    //note pour une case
  for (j=J1; j<=J2; j++) {
   k= K1;         //1re colonne
   do {
    Z=0;          //initialisation du contenu
    P=j+k;        //1re des 5 cases
    for (i=1; i<=5; i++) {
     Z=Z+A[P];    //calcul du contenu
     P=P+C;       //case suivante dans la srie
    }
    Note=Valeur[Z];
    if (Note != 0.0) {
     //affectation de la note  chaque case du groupe
     P=j+k;
     for (i=1; i<=5; i++) {
      B[P]= B[P]+Note;
      P=P+C;
     } 
    }
    k=k+10;
   } while (k<=K2);
  }
 }

 int Ordijeu() {
  int Ordirep=0;
  int q,j,h,v;
  double NoteMax;
  String ws;
  for (j=0; j<100; j++) B[j]=0.0;  //rinitialisation des scores
  CalcNote(1,0,5,0,90);  //balayage horizontal
  CalcNote(9,4,9,0,50);  //balayage diag2
  CalcNote(10,0,9,0,50); //balayage vertical
  CalcNote(11,0,5,0,50); //balayage diag1
  NoteMax=-1;
  for (j=0; j<100; j++) {
   if ((B[j]>NoteMax) && (A[j]==0)) {
    Ordirep=j;
    NoteMax=B[Ordirep];
   }
   else if ((B[j]==NoteMax) && (A[j]==0)) {
    if (Math.random()<0.5) Ordirep=j;
   } 
  } 
  h=Ordirep/10;
  v=Ordirep-10*h;
  //str(h,ws);
  //ws:= chr(v+ord('A'))+ws;
  //SetDialog('Je joue '+ws);
  A[Ordirep]=5;
  NombreCoups=NombreCoups+1;
  Affiche(1);
  Ordirep=0;
  if ((NombreCoups==50) || ((NoteMax==0) && (NombreCoups>1)))
   Ordirep=2;     //match nul
  if (NoteMax>=Valeur[20]) Ordirep=1; //victoire de l'ordinateur
  return Ordirep;
 }
 
 public int controle(int k) {
  int rep=0;
  int renvoi=0;
  if (B[k]>Valeur[4]) {
   //victoire du joueur
   Solve(1);
   MsgLabel.setText("BRAVO!!!");
   renvoi=1;
  }
  else {
   rep= Ordijeu();  //l'ordinateur calcule son coup
   if (rep == 2) {
    MsgLabel.setText("Match nul !!!");
    renvoi=2;
   }
   else if (rep == 1) {
    Solve(5);
    MsgLabel.setText("J'AI GAGNE !!!");
    renvoi=5;
   }
   else MsgLabel.setText("A vous...");
  }
  return renvoi;
 }
 
 public boolean mouseDown(Event evt, int x, int y) {
  int i=-1;
  int j=-1;
  if ((x>MargeX+LCase) & (x<MargeX+11*LCase)) 
   i=(x-MargeX-LCase)/LCase;
  if ((y>MargeY+LCase) & (y<MargeY+11*LCase)) 
   j=(y-MargeY-LCase)/LCase;
  if (Fini==0 && i>=0 && j>=0 && A[10*j+i]==0) {
   A[10*j+i]=1;
   Affiche(1);
   Fini=controle(10*j+i);
   //if (Fini==5) Solve('X');
   //else if (Fini==1) Solve('O');
   if (Fini!=0) Affiche(1);
  }
  else if (Fini!=0) {
   Initialise();
   Affiche(0);
  } 
  return true;
 }
 
}

// applet Morpion
public class morpion extends Applet {
 Label MsgLabel;
 MorpionView ZoneJeu;
 
 public void init() {
  setLayout(new BorderLayout());
  MsgLabel=new Label("A vous de jouer...");
  add("South",MsgLabel);
  ZoneJeu= new MorpionView(MsgLabel);
  add("Center",ZoneJeu);
 }

}

