import java.awt.*;
import java.awt.event.*;
import java.applet.*;

public class Urne extends Applet {

 UrneArbre arbre=new UrneArbre();
 
 public void init() {
  setBackground(Color.white);
  parametrise();
  setLayout(new BorderLayout(4,4));
  add(BorderLayout.CENTER,arbre);
 }
 
 void parametrise() {
  //lecture des paramtres
  String S;
  S=getParameter("remise");
  if (S!=null && S.equals("oui")) arbre.urne.remise=true;
  S=getParameter("tirage");
  if (S!=null) 
   try {
    arbre.urne.nbTirage=Integer.parseInt(S);
   } catch (Exception e) {
    arbre.urne.nbTirage=3;
   }
  S=getParameter("probas");
  if (S!=null && S.equals("oui")) arbre.montreProba=true; 
  defUrne(getParameter("bleu"),getParameter("rouge"),getParameter("vert"));
 }

 public int convertir(String nStr, int valDef) {
  int n=valDef;
  if (nStr!=null) 
   try {
    n=Integer.parseInt(nStr);
   } catch (Exception e) {
    n=valDef;
   }
  return n;
 }
 
 public void defUrne(String bstr, String rstr, String vstr) {
  int b=convertir(bstr,arbre.urne.nbBleu);
  int r=convertir(rstr,arbre.urne.nbRouge);
  int v=convertir(vstr,arbre.urne.nbVert);
  arbre.urne.defUrne(b,r,v);
 }

 public void defMode(int n) {
  arbre.urne.nbTirage=n;
  arbre.urne.resetChoix();
 }

 public void defRemise(boolean b) {
  arbre.urne.remise=b;
  arbre.urne.initProbas();
 }

 public void montreProba(boolean b) {
  arbre.montreProba=b;
 }
 
 public void dessiner() {
  arbre.repaint();
 }

 public void tirages(int n) {
  arbre.urne.faireTirage(n);
  arbre.repaint();
 }
 
 public Insets getInsets() {
  return new Insets(4,4,4,4);
 }
 
}
