/*
 * Copyright (c) 2000 Kostrzewa Bruno
 *
 * Permission to use, copy, hack, and distribute this software and its
 * documentation for NON-COMMERCIAL purposes and without fee is hereby
 * granted provided that this copyright notice appears in all copies.
 *
 * calkul.java
 * JDK 1.1
 * Version 1.0 Rvision 15/06/2000
 * Applet invisible interprtant une chane de caractres
 * en tant que formule mathmatique.
 * Version 1.1 Rvision 10/07/2006
 * Insertion d'une image reprsentant l'applet
 */

import java.util.*;
import java.applet.*;
import java.awt.*;
import jkb.calkul.*;
import jkb.utils.Div;

/**
 * Applet non affichable permettant  JavaScript d'effectuer
 * des calculs.
 * Dans le fichier html mettre width et height  0
 */
public class calkul extends Applet {
 int modeAngle=MathNode.mRadian;
 public Hashtable dico;
 Image img=null;

 public void init() {
  dico=new Hashtable();
  MathNode.initDico(dico);
  MathNode.defVar("REP",0.0,dico);
  String S=getParameter("radian");
  if (S!=null) {
   if (S.equals("non")) modeAngle=MathNode.mDegre;
  }
  img=Toolkit.getDefaultToolkit().getImage(getClass().getClassLoader().getResource("calkul.gif"));
 }
 
 public String eval(String com) {
  String rep="";
  double d=EvalStr.eval(com,dico,modeAngle);
  if (!Div.errCalc(d)) {
    MathNode.defVar("REP",d,dico);
    rep=Div.DoubleToStr(d,8);
   }
  else rep=EvalStr.evalStr(com,dico,modeAngle); 
  return rep;
 }

 public void setvar(String nom, double d) {
  MathNode.defVar(nom,d,dico);
 }

 public void paint(Graphics g) {
  if (img!=null) g.drawImage(img,0,0,this);    
 } 
}

