/*
 * Copyright (c) 1999-2000 Kostrzewa Bruno
 *
 * Permission to use, copy, hack, and distribute this software and its
 * documentation for NON-COMMERCIAL purposes and without fee is hereby
 * granted provided that this copyright notice appears in all copies.
 * 
 * Point.java
 * JDK 1.1  
 * Version 1.2 Rvision 01/08/2000
 * Partie du package imageo fournissant l'objet point libre
 * anctre de tous les autres types de point.
 *
 */

package jkb.imageo;

import java.util.Vector;

/**
 * Classe reprsentant un point libre, c'est  dire dplaable
 * dans tous les sens..
 **/
public class Point extends ObjImageo {
 
 public Point(int typ) {
  super(typ);
 }
 
 /**
  * Constructeur du point libre de coordonnes (x,y).
  */
 public Point(Vector V) {
  super(iPoint);
  double d;
  stInitOk=true;
  stMobile=true;
  if ("NN".equals(V.elementAt(V.size()-1))) {
   datas[0]=((Double)V.elementAt(0)).doubleValue();
   datas[1]=((Double)V.elementAt(1)).doubleValue();
  }
  else if ("".equals(V.elementAt(V.size()-1))) {
   if (Math.random()<0.5) d=-1.0;
   else d=1.0;
   datas[0]=d*5*Math.random();
   if (Math.random()<0.5) d=-1.0;
   else d=1.0;
   datas[1]=d*5*Math.random();
  } 
  else stInitOk=false;
 }

 /**
  * Recalcule les coordonnes du point.
  */
 public void calcDatas() {
  stCalcOk=true;
 }
 
 /**
  * Dplacement du point.
  */
 public void bougeVers(double x, double y) {
  datas[0]=x;
  datas[1]=y;
 }

}

