/*
 * Copyright (c) 1999 Kostrzewa Bruno
 *
 * Permission to use, copy, hack, and distribute this software and its
 * documentation for NON-COMMERCIAL purposes and without fee is hereby
 * granted provided that this copyright notice appears in all copies.
 * 
 * Couleur.java
 * JDK 1.1  
 * Version 1.0 Rvision 27/06/2000
 * Partie du package jkb traduisant des noms de couleur franais
 * en objets Color.
 *
 */

package jkb.utils;

import java.awt.Color;

public class Couleurs {

 /**
  * Fonction de traduction des couleurs.
  */
 public static Color donneCouleur(String S) {
  if (S.compareTo("NOIR")==0) return Color.black;
  else if (S.compareTo("BLEU")==0) return new Color(0x000080);
  else if (S.compareTo("CYAN")==0) return new Color(0x008080);
  else if (S.compareTo("GRIS")==0) return new Color(0x808080);
  else if (S.compareTo("GRISCLAIR")==0) return new Color(0xC0C0C0);
  else if (S.compareTo("MAGENTA")==0) return new Color(0x800080);
  else if (S.compareTo("BRUN")==0) return new Color(0x808000);
  else if (S.compareTo("ROUGECLAIR")==0) return new Color(0xFF0000);
  else if (S.compareTo("ROUGE")==0) return new Color(0x800000);
  else if (S.compareTo("BLANC")==0) return Color.white;
  else if (S.compareTo("JAUNE")==0) return Color.yellow;
  else if (S.compareTo("VERT")==0) return new Color(0x008000);
  else if (S.compareTo("VERTCLAIR")==0) return new Color(0x00FF00);
  else if (S.compareTo("BLEUCLAIR")==0) return new Color(0x0000FF);
  else if (S.compareTo("MAGENTACLAIR")==0) return new Color(0xFF00FF);
  else if (S.compareTo("CYANCLAIR")==0) return new Color(0x00FFFF);
  else return Color.black;
 } 
 
}

