/*
 * Copyright (c) 1999-2000 Kostrzewa Bruno
 *
 * Permission to use, copy, hack, and distribute this software and its
 * documentation for NON-COMMERCIAL purposes and without fee is hereby
 * granted provided that this copyright notice appears in all copies.
 * 
 * FileStr.java
 * JDK 1.1  
 * Version 1.1 Rvision 8/7/2000
 * Partie du package utils permettant de lire un texte dans un fichier
 * fourni par une URL.
 *
 */

package jkb.utils;

import java.util.*;
import java.net.*;
import java.io.*;

public class FileStr {

 private FileStr() {
 }
 
 public static String lireChaineFichier(URL source) {
  String rep="";
  try {
   String ligne = "";
   BufferedReader br = new BufferedReader
          (new InputStreamReader(source.openStream()));
   while (null != (ligne = br.readLine()))
    if (!ligne.startsWith(";")) rep=rep+ligne+"\n";
   br.close();         
  }
  catch(Exception e) {
   rep=null;
  }
  return rep;
 }
  
}

